#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#       Copyright (C) 2007-2008 Simonenko Sergey <gforgx@gmail.com>
#
#       Redistribution and use in source and binary forms, with or without
#       modification, are permitted provided that the following conditions are
#       met:
#
#       * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#       * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following disclaimer
#       in the documentation and/or other materials provided with the
#       distribution.
#       * Neither the name of the project NoteFinder and author's name nor the names of 
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
#       THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#      "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#       LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#       A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#       OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#       SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#       LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#       DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#       THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#       (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#       OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

from PyQt4 import Qt

from notefinderlib.notefinder.notefinder_rc import *

class Plugin(Qt.QAction):
    """ Base Plugin class """
    def __init__(self, parent):
        """ Initialization """
        Qt.QAction.__init__(self, parent)
        self.app = parent
        
    def onLoad(self):
        """ Describe here what your plugin should do on load """
        pass

    def do(self):
        """ Describe here what your plugin does """
        pass
    
    def showTrayMessage(self, message):
        self.app.tray.showMessage(self.text(), self.trUtf8(message), self.main.tray.Information, 10000)
    
    def showMessage(self, message):
        self.app.showMessage(message)
    
    def load(self):
        self.app.mW.ui.menuPlugins.addAction(self)
        self.app.mW.ui.pluginsToolbar.addAction(self)
        self.connect(self.app, Qt.SIGNAL('notebookChanged()'), self.onLoad)
        self.connect(self, Qt.SIGNAL('triggered()'), self.do)
        self.connect(self, Qt.SIGNAL('done()'), self.app.refresh)
        self.onLoad()
    
    def addToTray(self):
        self.app.pluginsMenu.addAction(self)